<?php
class ControllerPaymentPortwallet extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('payment/portwallet');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
                    
                    
			$d = $this->model_setting_setting->editSetting('portwallet', $this->request->post);
                        
			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', array('token' => $this->session->data['token'],'type'=>'payment'), ''));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_sale'] = $this->language->get('text_sale');

		$data['app_key'] = $this->language->get('entry_appkey');
                $data['secret_key'] = $this->language->get('entry_secretkey');
               // $data['service_charge'] = $this->language->get('entry_service_charge');
               // $data['success_url'] = $this->language->get('entry_success_url');
               // $data['cancel_url'] = $this->language->get('entry_cancel_url');
		$data['entry_sandbox'] = $this->language->get('entry_sandbox');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
                $data['entry_order_status_accepted'] = $this->language->get('entry_order_status_accepted');
                $data['entry_order_status_rejected'] = $this->language->get('entry_order_status_rejected');
		
		
		
		
		$data['entry_status'] = $this->language->get('entry_status');

		$data['help_test'] = $this->language->get('help_test');
		
		$data['help_total'] = $this->language->get('help_total');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['email'])) {
			$data['error_email'] = $this->error['email'];
		} else {
			$data['error_email'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], '')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], '')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/portwallet', 'token=' . $this->session->data['token'], '')
		);

		$data['action'] = $this->url->link('payment/portwallet', 'token=' . $this->session->data['token'], '');

		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], '');

		if (isset($this->request->post['portwallet_app_key'])) {
			$data['portwallet_app_key'] = $this->request->post['portwallet_app_key'];
		} else {
			$data['portwallet_app_key'] = $this->config->get('portwallet_app_key');
		}
                
                if (isset($this->request->post['portwallet_secret_key'])) {
			$data['portwallet_secret_key'] = $this->request->post['portwallet_secret_key'];
		} else {
			$data['portwallet_secret_key'] = $this->config->get('portwallet_secret_key');
		}
                
  //               if (isset($this->request->post['portwallet_service_charge'])) {
		// 	$data['portwallet_service_charge'] = $this->request->post['portwallet_service_charge'];
		// } else {
		// 	$data['portwallet_service_charge'] = $this->config->get('portwallet_service_charge');
		// }
                if (isset($this->request->post['portwallet_success_url'])) {
			$data['portwallet_success_url'] = $this->request->post['portwallet_success_url'];
		} else {
			$data['portwallet_success_url'] = $this->config->get('portwallet_success_url');
		}
                if (isset($this->request->post['portwallet_cancel_url'])) {
			$data['portwallet_cancel_url'] = $this->request->post['portwallet_cancel_url'];
		} else {
			$data['portwallet_cancel_url'] = $this->config->get('portwallet_cancel_url');
		}

		if (isset($this->request->post['portwallet_sandbox'])) {
			$data['portwallet_sandbox'] = $this->request->post['portwallet_sandbox'];
		} else {
			$data['portwallet_sandbox'] = $this->config->get('portwallet_sandbox');
		}
                if (isset($this->request->post['portwallet_status'])) {
			$data['portwallet_status'] = $this->request->post['portwallet_status'];
		} else {
			$data['portwallet_status'] = $this->config->get('portwallet_status');
		}
                if (isset($this->request->post['portwallet_order_status_accepted'])) {
			$data['portwallet_order_status_accepted'] = $this->request->post['portwallet_order_status_accepted'];
		} else {
			$data['portwallet_order_status_accepted'] = $this->config->get('portwallet_order_status_accepted');
		}
                if (isset($this->request->post['portwallet_order_status_rejected'])) {
			$data['portwallet_order_status_rejected'] = $this->request->post['portwallet_order_status_rejected'];
		} else {
			$data['portwallet_order_status_rejected'] = $this->config->get('portwallet_order_status_rejected');
		}


                $this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();


		

		if (isset($this->request->post['portwallet_status'])) {
			$data['portwallet_status'] = $this->request->post['portwallet_status'];
		} else {
			$data['portwallet_status'] = $this->config->get('portwallet_status');
		}

		if (isset($this->request->post['portwallet_sort_order'])) {
			$data['portwallet_sort_order'] = $this->request->post['portwallet_sort_order'];
		} else {
			$data['portwallet_sort_order'] = $this->config->get('portwallet_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/portwallet.tpl', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/portwallet')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

//		if (!$this->request->post['portwallet_appkey']) {
//			$this->error['error_appkey'] = $this->language->get('error_appkey');
//		}
//                if (!$this->request->post['portwallet_secretkey']) {
//			$this->error['error_secretkey'] = $this->language->get('error_secretkey');
//		}

		return !$this->error;
	}
}