<?php
class ControllerExtensionPaymentPortwallet extends Controller {

    public function index() {

      
        $this->language->load('payment/portwallet');

        $data['text_testmode'] = $this->language->get('text_testmode');
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['portwallet_order_status'] = $this->language->get('entry_order_status');


        $data['app_key'] = $this->config->get('portwallet_app_key');
        $data['secret_key'] = $this->config->get('portwallet_secret_key');
        //$data['service_charge'] = $this->config->get('portwallet_service_charge');
        $data['status'] = $this->config->get('portwallet_status');
        $data['success_url'] = $this->config->get('portwallet_success_url');
        $data['cancel_url'] = $this->config->get('portwallet_cancel_url');
        $data['testmode'] = $this->config->get('portwallet_sandbox');




        $this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        if ($order_info) {

            $data['item_name'] = html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8');

            $data['products'] = array();

            foreach ($this->cart->getProducts() as $product) {
                $option_data = array();

                foreach ($product['option'] as $option) {
                    if ($option['type'] != 'file') {
                        $value = $option['value'];
                    } else {
                        $upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

                        if ($upload_info) {
                            $value = $upload_info['name'];
                        } else {
                            $value = '';
                        }
                    }

                    $option_data[] = array(
                        'name' => $option['name'],
                        'value' => (utf8_strlen($value) > 20 ? utf8_substr($value, 0, 20) . '..' : $value)
                    );
                }

                $data['products'][] = array(
                    'name' => htmlspecialchars($product['name']),
                    'model' => htmlspecialchars($product['model']),
                    'price' => $this->currency->format($product['price'], $order_info['currency_code'], false, false),
                    'quantity' => $product['quantity'],
                    'option' => $option_data,
                    'weight' => $product['weight']
                );
            }
            $params = array('currency' => $order_info['currency_code'],
                'amount' => $order_info['total'],
                'name' => html_entity_decode($order_info['payment_firstname'], ENT_QUOTES, 'UTF-8') . " " . html_entity_decode($order_info['payment_lastname'], ENT_QUOTES, 'UTF-8'),
                'email' => $order_info['email'],
                'address' => html_entity_decode($order_info['payment_address_1'], ENT_QUOTES, 'UTF-8') . "<br>" . html_entity_decode($order_info['payment_address_2'], ENT_QUOTES, 'UTF-8'),
                'phone' => '01726919674',
                'product_name' => htmlspecialchars($product['name']),
                'country' => $order_info['payment_iso_code_2'],
                'state' => 'N/A',
                'city' => 'N/A',
                'zipcode' => 'N/A',
                'product_description' => $data['products'][0]['name']."<br>Model: ".$data['products'][0]['model']."<br>Quantity: ".$data['products'][0]['quantity'],

                'ipn_url' => $this->url->link('extension/payment/portwallet/callback', '', ''),
                'redirect_url' => $this->url->link('extension/payment/portwallet/redirect', '', ''), //$this->url->link('checkout/success')
                'oc_order_id' => $this->session->data['order_id']
            );
            // var_dump($params);die();
            // Generate invoice
            $data = $this->portwallet_generateInvoice($params);
            //var_dump($data);
            $invoice = $data->invoice_id;
            $gatewayTestUrl = "http://sandbox.portwallet.com/payment/";
            $gatewayLiveUrl = "http://payment.portwallet.com/payment/";

            $portwalletUrl = ($this->config->get('portwallet_sandbox') == '1') ? $gatewayTestUrl : $gatewayLiveUrl;
            
            $toPortwallet['invoice'] = $data->invoice_id;

            if (!isset($data->invoice_id) || $data->invoice_id == '') {
                return false;
            }
            // invoice will be insert
            $location = $portwalletUrl . '?' . http_build_query($toPortwallet);
            echo '<script>window.location.href="' . $location . '"</script>';
            exit();

            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/portwallet.tpl')) {
                return $this->load->view($this->config->get('config_template') . '/template/payment/portwallet.tpl', $data);
                  die('hi');
            } else {
                return $this->load->view('default/template/payment/portwallet.tpl', $data);
            }
        }
    }

    public function portwallet_generateInvoice($params) {
        $_params = $params;
        $_params['call'] = "gen_invoice";
        $data = $this->portwallet_process("post", $_params);

        if ($data->status == 200) {
            return $data->data;
        } else {
            return false;
        }
    }

    public function portwallet_process($method = "get", $_params) {
        $_params['timestamp'] = time();
        $_params['app_key'] = $this->config->get('portwallet_app_key');
        $_params['token'] = md5($this->config->get('portwallet_secret_key') . $_params['timestamp']);
        return $this->portwallet_request($method, $_params);
    }

    public function portwallet_request($method, $_params) {
        if (!$this->config->get('portwallet_sandbox')) {
            $api = 'http://www.portwallet.com/api/v1/';
        } else {
            $api = 'http://sandbox.portwallet.com/api/v1/';
        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $api);
        if ($method == "post") {
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $_params);
        }

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        //print_r( $response);die();
        $info = curl_getinfo($ch);

        curl_close($ch);
        if ($info['http_code'] == 200 && !empty($response)) {
            return json_decode($response);
        }
        else
            return false;
    }

    public function portwallet_ipnValidation($invoice, $amount) {
        $params['invoice'] = $invoice;
        $params['amount'] = $amount;
        $params['call'] = "ipn_validate";
        $data = $this->portwallet_process("post", $params);

        if ($data->status == 200) {
            return $data->data;
        } else {
            return false;
        }
    }

    public function callback() {

        if (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] == "POST" && !isset($_GET['invoice'])) {
            // IPN validation and add order history
            $data = $this->portwallet_ipnValidation($_POST['invoice'], $_POST['amount']);
            $this->load->model('checkout/order');
            $order_status_accepted = $this->config->get('portwallet_order_status_accepted');
            $order_status_rejected = $this->config->get('portwallet_order_status_rejected');
            if($data)
            {
                $order_info = $this->model_checkout_order->getOrder($data->oc_order_id);
                
                if($data->status == "ACCEPTED" && $order_info['total'] <= $data->amount)
                {
                    $this->model_checkout_order->addOrderHistory($data->oc_order_id, $order_status_accepted, "Portwallet ID: ".$data->invoice_id, true);
                }elseif($data->status == "REJECTED")
                {
                    $this->model_checkout_order->addOrderHistory($data->oc_order_id, $order_status_rejected, "Portwallet ID: ".$data->invoice_id, true);
                }
            }
        } 
    }

    public function redirect(){
       
        if (isset($_GET['invoice']) && !empty($_GET['invoice']) && isset($_GET['status']) && !empty($_GET['status'])) {
            if ($_GET['status'] == "ACCEPTED")
                header("Location: " . $this->url->link('checkout/success'));
            else {
                $this->session->data['error'] = "Your payment has been declined. Please try another card/method.";
                header("Location: " . $this->url->link('checkout/checkout'));
            }
        }

    }


}